//C++ header - Blue Marble Viewer - Copyright (C) 2002 Don Burns 
//Distributed under the terms of the GNU GENERAL PUBLIC LICENSE (GPL)
//as published by the Free Software Foundation.
#ifndef BMV_TEXT_H
#define BMV_TEXT_H

#ifdef WIN32

#include <windows.h>

#endif

#include <string>
#include <map>

#include <GL/gl.h>


class Text {
    public:
	enum Font {
	    BitmapFont,
	    FilledFont,
	    OutlineFont,
	    StrokeFont,
		LastFont
	};	
	Text();
	void drawString( Font, std::string );
	static Text *getSingleton();
	void *operator new( size_t size );

    protected:

	static Text *theText;

    private :

	GLuint fontmap[LastFont];
	GLuint loadFont(Font font);

	bool createStrokeFont( GLuint fontBase );
	bool createOutlineFont( GLuint fontBase );
	bool createFilledFont( GLuint fontBase );
	bool createBitmapFont( GLuint fontBase );

};

#endif
