#include <stdio.h>
#include <unistd.h>

#include <Producer/Thread>
#include <Producer/RenderSurface>

using namespace Producer;

class yada : public Producer::Thread
{
	public:
	    yada( RenderSurface &rs): _rs(rs) {}

		void *run( void )
		{
			printf( "Thread %d running, waiting for realize...\n", getpid() );
			_rs.waitForRealize();
			printf( "Thread %d: waitForRealize returned\n", getpid());
			for( ;; ) sleep(1);
		}

    private :
		RenderSurface &_rs;
};

class RealizeCallback : public RenderSurface::Callback
{
	public:
			void operator()(const RenderSurface & ) 
			{
				printf( "Realize callback called\n" );
			}

};

int main()
{
	RenderSurface rs;
	rs.setWindowRect(0,0,200,200);
	rs.setRealizeCallback( new RealizeCallback );
	yada y(rs);
	printf( "Master thread %d running\n", getpid() );

	y.startThread();

	sleep(2);
	printf( "master realizing render surface\n" );
	rs.realize();

	sleep(2);
	printf( "master canceling slave thread\n" );
	y.cancel();
	y.join();

	puts( "DONE" );
	return 0;

}
